
test := method(
write("Testing if async message is processed during yield:\n")

obj := Object clone
obj didProcess := Nil
obj foo := method(a,
  write("  processing async message\n")
  didProcess = 1
  return a * 2
)

f := obj @foo(111)
if (obj didProcess, Error raise("Error", "message send synchronously\n"))
r := f ?(isWaitingFuture)

if(f ?isWaitingFuture,
  write("  ?isWaitingFuture worked, manualy yielding now\n")
  //yield
)

write("  result = ", f, "\n")
if ( f == 222, write("Test succeeded\n"), write("Test failed\n"));

write("\n\nTesting if sending a message to a future yields until it is ready:\n")

obj didProcess := Nil
f := obj @foo(111)
if (obj didProcess, Error raise("Error", "message send synchronously\n"))
f type
write("  result = ", f, "\n")
if ( f == 222 and obj didProcess, write("Test succeeded\n"), write("Test failed\n"));
)

test
System collectGarbage


