

Shared := Object clone do(
    buffer := Buffer clone
)
Consumer := Shared clone do(
    consume := method(
	loop(
	    r := buffer asString
	    if(r size > 0) then(
		write("Consumer got: '", r, "'\n")
		buffer empty
	    ) else(
		write("Consumer waiting\n")
	    )
	    yield
	)
    )
)

Producer := Shared clone do(
    produce := method(
	i := 1
	loop(
	    buffer appendSeq(self uniqueId, "_", i asString, " ")
	    i = i + 1
	    yield
	)
	exit
    )
)

Producer clone @produce
Producer clone @produce
Producer clone @produce
Consumer @consume
while (activeCoroCount > 3, 
    writeln(activeCoroCount, " coros")
    yield
)