test := method(name, a, writeln(name, if(a, "OK", "FAILED")))

db := SQLite clone
name := "myDatabase.sqlite"
File clone setPath(name) remove

db setPath("myDatabase.sqlite")
db open
db exec("CREATE TABLE Dbm (key, value)")
db exec("CREATE INDEX DbmIndex ON Dbm (key)")

db exec("INSERT INTO Dbm ('key', 'value') VALUES ('a', '123')")
db exec("INSERT INTO Dbm ('key', 'value') VALUES ('a', 'efg')")
rows := db exec("SELECT key, value FROM Dbm WHERE key='a'")
test("SQLite insert: ", rows size == 2)

db exec("DELETE FROM Dbm WHERE key='a'")
rows := db exec("SELECT key, value FROM Dbm WHERE key='a'")
test("SQLite delete: ", rows size == 0)


db close
File clone setPath(db path) remove