// example of a UDP time client

TimeClient := UDPReceiver clone do(
    setPort(8081)
    newSlot("result", Nil)
    
    handleUDPPacketFromIP := method(packet, ip, 
	setResult(packet)
	write("got time:", packet, "\n")
    )

    getTime := method(ip,
	writeln("sending time request to ", ip)
	self @start
	
	socket := Socket setHost(ip) setPort(8080) udpOpen 
	if (socket error, writeln(socket error))
	
	socket write("what time is it?")
	if (socket error, writeln(socket error))
	
	while(result == Nil, 
	    write("wating for response\n")
	    yield
	)
	
	self stop
	result
    )
)

ip := if(?args at(0), args at(0), "127.0.0.1")
TimeClient getTime(ip)