
// UNFINISHED

Token := Object clone do(
  newSlot("name", "")
  newSlot("string", "")
)

LexerException := Exception clone

Lexer := Object clone do(
    newSlot("string", Nil)
    newSlot("index", 0)
    
    marks := List clone
    
    parse := method(s,
	if (s, setString(s))
	try(readObjcMessage) 
    )
    
    pushMark := method(marks push(index))
    popMark  := method(if (marks size > 0, index = marks pop))
    
    grabToken := method(name,
	s := string substring(marks at(marks size - 2), marks last)
	write("grab ", name, " token '", s, "'\n")
	tokens add(Token clone setName(type) setString(s))
    )
    
    nextCharacter := method(
	c := s at(index) 
	index = index + 1
	c
    )
    
    readObjcMessage := method(
	pushMark
	try(
	    readOpenBracket
	    readWord
	    readWhiteSpace
	    readMessageLabel
	    readCloseBracket
	) catch(LexerException, popMark) pass
    )
    
    error := method(popMark; LexerException raise("Error", sender thisMessage name))
    
    readOpenBracket := method(
	pushMark
	if (nextCharacter != "[" asCharacter, error)
	popMark
    )

    readCloseBracket := method(
	pushMark
	if (nextCharacter != "[" asCharacter, error)
	popMark
    )
        
    readWord := method(
	pushMark
	while (nextCharacter isAlphaNumeric, Nop)
	if (index == marks last, error)
	popMark
    )
    
    readWhiteSpace := method(
	pushMark
	while (nextCharacter isSpace, Nop)
	if (index == marks last, error)
	popMark
    )
    
    readMessageLabel := method(
	pushMark
	try(
	    readWord
	    readWhiteSpace
	    readMessageLabel
	    readCloseBracket
	) catch(LexerException, popMark) pass
    )
)


