optionalArg := method(i, defaultValue,
        arg := sender thisMessage argAt(i)
        if (arg isNil, sender getSlot("thisBlock") getSlot(defaultValue), sender sender doMessage(arg))
)

blockFromMessage := block(message, scope,
    count := message arguments count
    argNames := message arguments select(i,v, i != count-1) mapInPlace(i, v, v name)
    body := message argAt(count-1)
    return Lobby getSlot("Block") clone setScope(scope) setMessage(body) setArgumentNames(argNames)
)

methodWithDefaults := block(
    bodyIndex := ((thisMessage arguments count) - 1)

    names := List clone
    defaults := List clone

    thisMessage arguments foreach(i, arg,
        if (i == bodyIndex, break)
        if (arg name == "updateSlot",
            names append(arg arguments first name fromTo(1,-1))
            #write("# ", arg arguments at(1) code)
            defaults apped(sender doMessage(arg arguments at(1)))
            #writeln(" = ", defaults last)
        ,
            names append(arg name)
            defaults append("Nil")
        )
    )

    body := thisMessage argAt(bodyIndex)

    outer := sender
    inner := Locals clone
    inner names := names
    inner defaults := defaults

    names reverseForeach(i, name,
        s := ("setSlot(\"" .. name .. "\", optionalArg(" .. i .. ", \"" .. name .. "Default\"))")
        m := s asMessage
        m setNextMessage(body)
        body := m
    )

    #writeln(names); writeln
    #writeln(defaults); writeln
    #writeln(body code); writeln
    
    b := Lobby getSlot("Block") clone setMessage(body) setArgumentNames(names)

    names foreach(i, name,
        getSlot("b") setSlot(name .. "Default", defaults at(i))
        #writeln(name .. "Default = ", defaults at(i))
    )

    return getSlot("b")
)

o := Object clone
o f := methodWithDefaults(x, y=3, writeln("f: ", x, " ", y))

o f(1, 2)
o f(3)
o f()

a := 2
b := 3
o g := methodWithDefaults(x=1, y=a, z=(a+b), writeln(x, " ", y, " ", z))
o g

o g(18)