
HiException := Exception clone
LoException := Exception clone

test := method(
    HI := 0
    LO := 0

    someFunction := method(n,
      try(hiFunction(n)) catch(Exception, write("shouldn't get here\n"))
    )

    hiFunction := method(n,
      try(loFunction(n)) catch(HiException, HI = HI + 1) pass
    )

    loFunction := method(n,
      try(blowup(n)) catch(LoException, LO = LO + 1) pass
    )

    blowup := method(n,
      if( n % (2) != (0)) then (
	LoException raise("", "")
      ) else (
	HiException raise("", "")
      )
    )

    N := if(?args at(0), args at(0) asNumber, 1)
    for(i, 1, N, someFunction(i))

    write("Exceptions: HI=", HI, " / LO=", LO, "\n")
)
test