#include "IoCLI.h"

void IoBindingsInit(IoState *self, IoObject *context); 

int main(int argc, const char *argv[])
{
    IoState *self = IoState_new();
    IoState_argc_argv_(self, argc, argv);
    #ifdef IOBINDINGS
    IoState_setBindingsInitCallback(self, (IoStateBindingsInitCallback *)IoBindingsInit);
    #endif
    IoState_init(self);
    
    {
    IoCLI *cli = IoCLI_new();
    IoCLI_state_(cli, self);
    IoCLI_run(cli);
    IoCLI_free(cli);
    }

    IoState_free(self);
    return 0;
}
